*  FILE: ADVENT02/ASM

*  <<LOOK>> SPECIAL PROCS

* LOOK DESK

LOOK01 EQU *
 LDA NOUNNO
 JSR CKOBJ
 BNE A@
 LDA #94 OPEN DESK
 JSR CKOBJ
 LBEQ NOSEE
 LDA #27+INV MICROFILM
 JSR CKOBJ
 LBEQ DMSG12
 JSR MAKVIS
 JSR CKDRAW
 JMP DMSG11
A@ TST DESKSW
 LBNE DMSG29
 LDX #MSG28
 JSR DISPLY
 JMP DMSG17

* LOOK TABLE

LOOK02 EQU *
 LDA #121 TABLE
 JSR CKOBJ
 LBEQ NOSEE
 LDA #18+INV MESSAGE
 JSR CKOBJ
 LBEQ DMSG12
 JSR MAKVIS
 JSR CKDRAW
 JMP DMSG30

* LOOK RUG

LOOK03 EQU *
 LDA #10 RUG
 JSR LOCOBJ
 LBNE DMSG12
 LDA #119 LADDER TO CELLAR
 JSR CKOBJ
 LBNE DMSG12
 JMP DMSG31

* LOOK DOOR

LOOK04 EQU *
 LDA ROOM
 CMPA #5
 BLO B@
 CMPA #8
 BHI B@
 BNE A@
 LDA #122 DEVICE
 JSR CKOBJ
 LBEQ NOSEE
A@ JMP DMSG12
B@ LDA NOUNNO
 JSR CKOBJ
 LBEQ NOSEE
 LDA #119 LADDER
 JSR CKOBJ
 LBNE DMSG12
 LDX #MSG31
 JSR DISPLY
 JMP DMSG29

* LOOK CHEST

LOOK05 EQU *
 LDA NOUNNO CHEST
 JSR LOCOBJ
 BNE A@
 LDA #31 OPEN CHEST
 JSR LOCOBJ
 BNE A@
 JMP NOSEE
A@ LDA CHSTSW
 LBEQ DMSG16
 CMPA #1
 LBEQ DMSG35
 CMPA #2
 LBEQ DMSG36
 JMP DMSG22

* LOOK CABINET

LOOK06 EQU *
 LDA ROOM
 CMPA #3
 LBNE NOSEE
 LDA #16+INV
 JSR CKOBJ
 BEQ A@
 JSR MAKVIS
 JSR CKDRAW
 JMP DMSG37
A@ LDX #MSG11
 JSR DISPLY
 JMP DMSG38

* LOOK LADDER

LOOK07 EQU *
 LDA ROOM
 CMPA #3
 LBEQ DMSG12
 JMP LOOKOB

* LOOK MANUAL

LOOK08 EQU *
 LDA NOUNNO
 JSR HAVOBJ
 LBEQ NOHAVE
 LDX #MSG31
 JSR DISPLY
 JMP DMSG42

* LOOK SWITCH

LOOK09 EQU *
 LDA ROOM
 CMPA #3
 LBNE DMSG12
 JMP NOSEE

* LOOK DEVICE

LOOK10 EQU *
 LDA #117 SPEAKER
 JSR CKOBJ
 LBNE DMSG14
 LDA #122 DEVICE
 JSR CKOBJ
 LBEQ NOSEE
 JMP DMSG44

* LOOK SPECS

LOOK11 EQU *
 LDA NOUNNO
 JSR HAVOBJ
 LBNE LOOKOB
 JMP NOHAVE

* LOOK BOAT

LOOK12 EQU *
 LDA #93 INFLATED BOAT
 JSR CKOBJ
 BEQ A@
 STA NOUNNO
A@ JMP LOOKOB

* LOOK FLASHLIGHT

LOOK13 EQU *
 LDA #8 FLASHLIGHT
 JSR LOCOBJ
 BNE A@
 LDA #9 LIT FLASHLIGHT
A@ STA NOUNNO
 JMP LOOKOB

* LOOK PATH

LOOK14 EQU *
 LDA ROOM
 CMPA #16
 BEQ A@
 CMPA #9
 LBNE NOSEE
A@ JMP DMSG12

* LOOK MICROFILM

LOOK15 EQU *
 LDA NOUNNO
 JSR HAVOBJ
 LBEQ NOHAVE
 LDA #11 SPECS
 JSR HAVOBJ
 LBEQ DMSG68
 JMP DMSG69

* LOOK ENER

LOOK16 EQU *
 LDA ROOM
 CMPA #6
 BEQ A@
 CMPA #7
 LBNE NOSEE
A@ JMP DMSG12

* LOOK HILL

LOOK17 EQU *
 LDA ROOM
 CMPA #8
 BEQ A@
 CMPA #15
 BEQ A@
 CMPA #16
 LBNE NOSEE
A@ JMP DMSG12

* LOOK FIELD

LOOK18 EQU *
 LDA ROOM
 CMPA #8
 LBEQ DMSG12
 JMP LOOKOB

* LOOK LAB

LOOK19 EQU *
 LDA ROOM
 CMPA #5
 LBEQ DMSG12
 JMP LOOKOB

* LOOK SHACK

LOOK20 EQU *
 LDA ROOM
 CMPA #19
 LBEQ DMSG12
 JMP LOOKOB

* LOOK SHED

LOOK21 EQU *
 LDA ROOM
 CMPA #17
 LBEQ DMSG12
 JMP LOOKOB

*  <<GET>> SPECIAL PROCS

* GET RUG

GET01 EQU *
 LDA #32 RUG OVER DOOR
 JSR CKOBJ
 BEQ A@
 LDA OBJCNT
 CMPA #MAXOBJ
 BHS A@
 LDA #32
 LDB #10
 JSR CHGOBJ
 LDA #120+INV TRAP DOOR
 JSR MAKVIS
 LDX #MSG33
 JSR DISPLY
A@ JMP VGET

* GET DESK OR TABLE

GET02 EQU *
 LDA NOUNNO
 JSR CKOBJ
 LBEQ NOSEE
 JMP DMSG34

* GET MANUAL/SPECS

GET03 EQU *
 LDA #30 CHEST
 JSR LOCOBJ
 BNE A@
 LDA #31 OPEN CHEST
 JSR LOCOBJ
 BNE A@
 BRA D@
A@ LDA NOUNNO
 CMPA #11 SPECS
 BNE B@
 LDA CHSTSW
 CMPA #1
 BNE D@
 LDA #11 SPECS
 BRA C@
B@ LDA CHSTSW
 CMPA #2
 BNE D@
 LDA #12
C@ LDB OBJCNT
 CMPB #MAXOBJ
 BHS D@
 JSR PUTOBJ
 INC CHSTSW
D@ JMP VGET

* GET MICE

GET04 EQU *
 LDA NOUNNO
 JSR CKOBJ
 BEQ A@
 LDA #16 MOUSETRAP
 JSR HAVOBJ
 BNE A@
 JMP DMSG66
A@ JMP VGET

* GET BOAT

GET05 EQU *
 LDA NOUNNO
 JSR LOCOBJ
 BNE A@
 LDA #93 INFLATED BOAT
 JSR CKOBJ
 LBNE DMSG76
A@ JMP VGET

* GET PADDLES

GET06 EQU *
 LDA #112 SNAKE
 JSR CKOBJ
 LBEQ VGET
 JMP DMSG81

* GET CHEST

GET07 EQU *
 LDA NOUNNO
 JSR LOCOBJ
 BNE A@
 LDA #31 OPEN CHEST
 STA NOUNNO
A@ JMP VGET

* GET FLASHLIGHT

GET08 EQU *
 LDA #8 UNLIT FLASH
 JSR LOCOBJ
 BNE A@
 LDA #9 LIT FLASH
 STA NOUNNO
A@ JMP VGET

*  <<PUT>> SPECIAL PROCS

* PUT MICE

PUT01 EQU *
 LDA NOUNNO
 JSR HAVOBJ
 LBEQ NOHAVE
 LDA #112 SNAKE
 JSR CKOBJ
 LBEQ VPUT
 CLRB
 JSR CHGOBJ
 JSR CKDRAW
 LDX #MSG82
 JSR DISPLY
 LDA NOUNNO
 CLRB
 JSR REPOBJ
 JMP REPLY

* PUT CHEST

PUT02 EQU *
 LDA NOUNNO
 JSR HAVOBJ
 BNE A@
 LDA #31 OPEN CHEST
 STA NOUNNO
A@ JMP VPUT

* PUT FLASHLIGHT

PUT03 EQU *
 LDA #8 UNLIT FLASH
 JSR LOCOBJ
 BNE A@
 LDA #9
 STA NOUNNO
A@ JMP VPUT

* PUT JEWELS

PUT04 EQU *
 LDA #13 JEWELS
 JSR HAVOBJ
 BEQ A@
 LDA #102 NATIVES
 JSR CKOBJ
 BEQ A@
 LDA #13 JEWELS
 CLRB
 JSR REPOBJ
 LDA #102
 JSR CHGOBJ
 JSR CKDRAW
 JMP DMSG97
A@ JMP VPUT

*  <<GO>> SPECIAL PROCS

* GO STAIRS

GO01 EQU *
 LDA ROOM
 CMPA #2
 LBHI NOSEE
 EORA #3
 JMP EXITRM

* GO LADDER/DOOR/CELLAR

GO02 EQU *
 LDA ROOM
 CMPA #3
 BNE A@
 LDA #1
 BRA C@
A@ LDA #119 LADDER
 JSR CKOBJ
 BNE B@
 LDA NOUNNO
 CMPA #97 CELLAR
 LBEQ DMSG32
 JSR CKOBJ
 LBEQ NOSEE
 LDX #MSG16
 JSR DISPLY
 JMP DMSG29
B@ LDA #3
C@ JMP EXITRM

* GO PASSAGE

GO03 EQU *
 LDA ROOM
 CMPA #3
 BEQ B@
 CMPA #5
 BEQ C@
 CMPA #4
 LBEQ DMSG14
A@ JMP NOSEE
B@ LDA #123 CABINET W/PASSAGE
 JSR CKOBJ
 BEQ A@
C@ LDA #4
 JMP EXITRM

* GO DEVICE

GO04 EQU *
 LDA #117 SPEAKER
 JSR CKOBJ
 LBNE DMSG14
 LDA #122 DEVICE
 JSR CKOBJ
 LBEQ NOSEE
 LDA ROOM
 CMPA #5
 BHI A@
 INCA
 INCA
A@ DECA
 JMP EXITRM

* GO FIELD

GO05 EQU *
 LDA ROOM
 CMPA #8
 LBEQ DMSG14
 CMPA #7
 LBNE NOSEE
 INCA
 JMP EXITRM

* GO PATH

GO06 EQU *
 LDA ROOM
 CMPA #16
 BNE A@
 LDA #18
 BRA B@
A@ LDA #115 BLOCKED PATH
 JSR CKOBJ
 BNE C@
 LDA #107 CLEAR PATH
 JSR CKOBJ
 LBEQ NOSEE
 LDA #10
B@ JMP EXITRM
C@ LDX #MSG28
 JSR DISPLY
 JMP DMSG50

* GO LAB

GO07 EQU *
 LDA ROOM
 CMPA #5
 LBEQ DMSG14
 CMPA #6
 LBNE NOSEE
 DECA
 JMP EXITRM

* GO SHED

GO08 EQU *
 LDA ROOM
 CMPA #17
 LBEQ DMSG14
 CMPA #16
 LBNE NOSEE
 INCA
 JMP EXITRM

* GO SHACK

GO09 EQU *
 LDA ROOM
 CMPA #19
 LBEQ DMSG14
 CMPA #18
 LBNE NOSEE
 INCA
 JMP EXITRM

* GO HILL

GO10 EQU *
 LDA ROOM
 CMPA #15
 BEQ A@
 CMPA #16
 BNE B@
A@ JMP DMSG13
B@ CMPA #8
 LBNE NOSEE
 LDA #15
 JMP EXITRM

* GO JUNGLE

GO11 EQU *
 LDA ROOM
 CMPA #9
 LBNE NOSEE
 JMP GO06

* GO CREVICE

GO12 EQU *
 LDA ROOM
 CMPA #10
 BEQ A@
 CMPA #11
 LBNE NOSEE
A@ EORA #1
 JMP EXITRM

* GO SHORE/BEACH

GO13 EQU *
 LDA ROOM
 CMPA #18
 BEQ A@
 CMPA #22
 BNE B@
A@ JMP DMSG13
B@ CMPA #20
 BNE D@
 LDA #18
C@ JMP EXITRM
D@ CMPA #21
 LBNE NOSEE
 INCA
 BRA C@

* GO BOAT

GO14 EQU *
 LDA #21 DEFLATED BOAT
 JSR LOCOBJ
 LBNE DMSG77
 LDA ROOM
 CMPA #20
 BEQ C@
 CMPA #21
 BEQ C@
 CMPA #24
 BEQ C@
 CMPA #25
 BEQ C@
 LDA #93 INFLATED BOAT
 JSR CKOBJ
 LBEQ NOSEE
 LDA ROOM
 CMPA #18
 BEQ A@
 CMPA #22
 LBNE DMSG88
 LDA #21
 BRA B@
A@ LDA #20
B@ JMP EXITRM
C@ JMP DMSG14

* GO CLEARING

GO15 EQU *
 LDA #98 CLEARING
 JSR CKOBJ
 LBEQ NOSEE
 LDA #23
 JMP EXITRM

* GO DOOR

GO16 EQU *
 LDA ROOM
 CMPA #5
 BNE A@
 INCA
 BRA E@
A@ CMPA #6
 BNE B@
 DECA
 BRA E@
B@ CMPA #7
 BNE C@
 INCA
 BRA E@
C@ CMPA #8
 BNE D@
 LDA #122 DEVICE
 JSR CKOBJ
 LBEQ NOSEE
 LDA #7
 BRA E@
D@ JMP GO02
E@ JMP EXITRM

* FEED VERB PROC

VFEED EQU *
 LDA NOUNNO
 CMPA #26 MICE
 BNE B@
 JSR HAVOBJ
 LBEQ NOHAVE
 LDA #112 SNAKE
 JSR CKOBJ
 BEQ C@
A@ LDA #26 MICE
 STA NOUNNO
 JMP PUT01
B@ CMPA #112 SNAKE
 LBNE BADINP
 JSR CKOBJ
 LBEQ NOSEE
 LDA #26 MICE
 JSR HAVOBJ
 BNE A@
C@ JMP DMSG32

* CUT VERB PROC

VCUT EQU *
 LDA NOUNNO
 CMPA #115 PATH
 BEQ A@
 CMPA #91 JUNGLE
 LBNE BADINP
A@ LDA #107 CUT PATH
 JSR CKOBJ
 BNE B@
 LDA #115 BLOCKED PATH
 JSR CKOBJ
 LBEQ DMSG23
 LDA #24 MACHETE
 JSR HAVOBJ
 LBEQ DMSG32
 LDA #115 BLOCKED PATH
 LDB #107 CUT PATH
 JSR CHGOBJ
 LDU #OVJUN8
 JSR SHOOVL
B@ JMP DMSG65

* KILL VERB PROC

VKILL EQU *
 LDA NOUNNO
 CMPA #112 SNAKE
 BEQ A@
 CMPA #110 JACK
 BEQ C@
 CMPA #102 NATIVES
 LBNE BADINP
 JSR CKOBJ
 BEQ B@
C@ JMP DMSG79
A@ JSR CKOBJ
 BEQ B@
 JMP DMSG80
B@ JMP NOSEE

* INFLATE VERB PROC

VINFL EQU *
 LDA NOUNNO
 CMPA #21 BOAT
 BEQ A@
 CMPA #90 AIR
 LBNE BADINP
A@ LDA #21 BOAT
 JSR HAVOBJ
 LBNE DMSG73
 LDA NOUNNO
 JSR CKOBJ
 BEQ B@
 LDA #14 PUMP
 JSR HAVOBJ
 LBEQ DMSG74
 LDA #21 BOAT
 LDB #93 INFLATED BOAT
 JSR CHGOBJ
 JSR CKDRAW
 JMP REPLY
B@ LDA #93 INFLATED BOAT
 JSR CKOBJ
 LBEQ NOSEE
 JMP DMSG75

* DEFLATE VERB PROC

VDEFL EQU *
 LDA NOUNNO
 CMPA #21 BOAT
 BEQ A@
 CMPA #90 AIR
 LBNE BADINP
A@ LDA #21 BOAT
 JSR LOCOBJ
 LBNE DMSG78
 LDA #93 INFLATED BOAT
 JSR CKOBJ
 LBEQ NOSEE
 LDB #21 DEFLATED BOAT
 JSR CHGOBJ
 TFR B,A
 JSR CKDRAW
 JMP REPLY

* ACTIVATE VERB PROC

VACTIV EQU *
 LDA NOUNNO
 CMPA #93 ENERGIZER
 LBNE BADINP
 LDA ROOM
 CMPA #6
 BEQ A@
 CMPA #7
 LBNE DMSG23
A@ INC ENERSW
 JMP DMSG54

* PRESS VERB PROC

VPRESS EQU *
 LDA NOUNNO
 CMPA #94 BUTTON
 LBNE BADINP
 LDA ROOM
 CMPA #6
 BEQ C@
 CMPA #7
 BEQ C@
 CMPA #3
 LBNE NOSEE
 LDA #123 CABINET
 JSR CKOBJ
 BEQ A@
 LDB #124
 BRA B@
A@ LDA #124
 LDB #123
B@ JSR CHGOBJ
 JSR CKDRAW
 JMP DMSG39
C@ TST ENERSW
 LBEQ DMSG55
 LDX #SCRTAB
 LDB #8
D@ LDA #6
E@ LDU A,X
 JSR SHOSC2
 DECA
 DECA
 BPL E@
 DECB
 BNE D@
 LDA ROOM
 EORA #1
 JMP EXITRM

* UNLIGHT VERB PROC

VUNLIT EQU *
 LDA NOUNNO
 CMPA #8 FLASH
 LBNE BADINP
 JSR LOCOBJ
 BNE A@
 LDA #9 UNLIT FLASH
 JSR HAVOBJ
 LBEQ NOHAVE
 LDB #8
 JSR REPOBJ
 CLR LITESW
 JSR INDARK
A@ JMP DMSG86

* LIGHT VERB PROC

VLIGHT EQU *
 LDA NOUNNO
 CMPA #8 FLASH
 LBNE BADINP
 LDA #9 LIT FLASH
 JSR LOCOBJ
 BNE A@
 LDA #8 UNLIT FLASH
 JSR HAVOBJ
 LBEQ NOHAVE
 TST LITECT
 LBEQ DMSG21
 JSR INDARK
 PSHS CC
 LDA #8 UNLIT FLASH
 LDB #9 LIT FLASH
 JSR REPOBJ
 INC LITESW
 PULS CC
 BNE A@
 JSR CLS
 JSR DRAWSC
A@ JMP DMSG85

* READ VERB PROC

VREAD EQU *
 LDA NOUNNO
 CMPA #125 SIGN
 BNE A@
 LDA ROOM
 CMPA #4
 BNE B@
 JMP DMSG47
A@ CMPA #12 MANU
 LBNE BADINP
 JSR HAVOBJ
 LBEQ NOHAVE
 LDA #117 SPEAKER
 JSR CKOBJ
 LBEQ DMSG48
 JMP DMSG53
B@ CMPA #19 SHACK
 BNE C@
 LDA #125 SIGN
 JSR CKOBJ
 BEQ C@
 JMP DMS101
C@ JMP NOSEE

* UNLOCK VERB PROC

VUNLOK EQU *
 LDA NOUNNO
 CMPA #126 DESK
 LBNE BADINP
 LDA ROOM
 CMPA #1
 LBNE NOSEE
 TST DESKSW
 BNE A@
 LDA #23 KEY
 JSR HAVOBJ
 LBEQ DMSG67
 INC DESKSW
A@ JMP DMSG19

* TRADE VERB PROC

VTRADE EQU *
 TST NOUNNO
 LBEQ BADINP
 BSR E@
 LDA ROOM
 CMPA #19
 LBNE DMSG23
 LDA #125 SIGN
 JSR CKOBJ
 LBNE DMSG32
 LDA NOUNNO
 JSR HAVOBJ
 LBEQ NOHAVE
 CMPA #10 RUG
 BEQ A@
 LDA #10 RUG
 JSR CKOBJ
 BEQ B@
 LDA NOUNNO
 CMPA #30 CHEST
 BEQ G@
 CMPA #31 CHEST
 BEQ G@
B@ LDX #MSG61
 JSR DISPLY
 LDA #10 RUG
 JSR CKOBJ
 LBEQ DMSG62
 LDA #30 CHEST
 JSR CKOBJ
 LBEQ DMSG63
 JMP REPLY
A@ LDX #MSG64
 JSR DISPLY
 INC TRADSW
 JMP VPUT
E@ LDA NOUNNO
 CMPA #30 CLOSED CHEST
 BNE F@
 JSR LOCOBJ
 BNE F@
 LDA #31 OPEN CHEST
 STA NOUNNO
F@ RTS
G@ TST POTTSW GOT POTTERY?
 BNE A@
 LDA #8 REMOVE DEVICE
 STA ROOM
 LDA #122 DEVICE
 CLRB
 JSR CHGOBJ
 LDA #19
 STA ROOM
 BRA A@

* BAIL VERB PROC

VBAIL EQU *
 LDA ROOM
 CMPA #24
 BEQ A@
 CMPA #25
 LBNE DMSG26
A@ LDA #15 BUCKET
 JSR LOCOBJ
 LBEQ DMSG32
 INC BAILSW
 LDA #101
 JSR CKDRAW
 JMP DMSG65

* ROW VERB PROC

VROW EQU *
 LDA #19 PADDLES
 JSR HAVOBJ
 LBEQ DMSG90
 LDA ROOM
 CMPA #20
 BEQ A@
 CMPA #21
 BEQ B@
 CMPA #24
 BEQ C@
 CMPA #25
 BEQ D@
 JMP DMSG89
A@ LDA #24
 BRA E@
B@ LDA #25
 BRA E@
C@ LDA #21
 BRA E@
D@ LDA #20
E@ JMP EXITRM

* DIG VERB PROC

VDIG EQU *
 LDA #20 SHOVEL
 JSR HAVOBJ
 LBEQ DMSG96
 LDA #29+INV POTTERY
 JSR MAKVIS
 BNE B@
 LDA #28+INV CROWN
 JSR MAKVIS
 LBEQ REPLY
 JSR CKDRAW
A@ JMP DMSG11
B@ JSR CKDRAW
 LDA #8 RESTORE DEVICE
 STA ROOM
 LDA #122 DEVICE
 CLRB
 JSR CHGOBJ
 JSR PUTOBJ
 LDA #23
 STA ROOM
 INC POTTSW SHOW GOT POTTERY
 BRA A@

* GIVE VERB PROC

VGIVE EQU *
 LDA NOUNNO
 CMPA #13 JEWELS
 LBNE BADINP
 LDA #102 NATIVES
 JSR CKOBJ
 LBEQ DMSG99
 JMP PUT04

* OPEN VERB PROC

VOPEN EQU *
 LDA NOUNNO
 CMPA #120 TRAP DOOR
 LBNE BADINP
 JSR CKOBJ
 LBEQ NOSEE
 LDA #119 LADDER
 JSR CKOBJ
 BEQ A@
 LDX #MSG28
 JSR DISPLY
 JMP DMSG18
A@ LDA #119+INV
 JSR MAKVIS
 JSR CKDRAW
 JMP DMSG11

* OPEN CHEST

OPEN01 EQU *
 LDA #31 OPEN CHEST
 JSR LOCOBJ
 BEQ B@
 LDX #MSG28
 JSR DISPLY
A@ JMP DMSG18
B@ LDA #30 CLOSED CHEST
 JSR HAVOBJ
 BEQ C@
 LDB #31 OPEN CHEST
 JSR REPOBJ
 BRA D@
C@ LDA #30 CLOSED CHEST
 JSR CKOBJ
 LBEQ NOSEE
 LDB #31 OPEN CHEST
 JSR CHGOBJ
 JSR CKDRAW
D@ INC CHSTSW
 BRA A@

* OPEN DESK

OPEN02 EQU *
 LDA #94 OPEN DESK
 JSR CKOBJ
 BNE A@
 LDA #126 CLOSED DESK
 JSR CKOBJ
 LBEQ NOSEE
 TST DESKSW
 LBEQ DMSG17
 LDA #126
 LDB #94
 JSR CHGOBJ
 TFR B,A
 JSR CKDRAW
A@ JMP DMSG18

*******************************
*  SPECIAL ROUTINE FOR GET
*  WHILE IN THE GRASS SHACK
*******************************

GETSHA EQU *
 LDA ROOM
 CMPA #19
 BNE C@
 LDA #125 SIGN
 JSR CKOBJ
 BNE C@
 TST TRADSW
 BNE B@
 LDA NOUNNO
 CMPA #128 ALL
 BEQ A@
 JSR HAVOBJ
 BNE C@
 LDA NOUNNO
 JSR CKOBJ
 BEQ C@
A@ JMP DMSG59
B@ LDA NOUNNO
 CMPA #128 ALL
 LBEQ DMSG60
 JSR HAVOBJ
 BNE C@
 LDA NOUNNO
 JSR CKOBJ
 BEQ C@
 CLR TRADSW
C@ RTS

*******************************
* CHECK FOR DARK AREA RTN
* CALLED FROM VLOOK
*******************************

INDARK EQU *
 PSHS X
 LDA ROOM
 CMPA #3
 BEQ A@
 CMPA #4
 BEQ A@
 CMPA #11
 BLO B@
 CMPA #14
 BHI B@
A@ LDA #9 LIT FLASH
 JSR LOCOBJ
 BNE B@
 LDU #SCRBLK
 JSR SHOSCR
 LDD #$0B00
 STD ROWCOL
 LDD #GSCRN+288*10
 STD SCRTOP
 LDX #MSG84
 JSR DISPLY
 CLRA
 BRA C@
B@ LDA #1
C@ TSTA
 PULS X,PC

*******************************
* ROUTINE PERFORMED FOR EACH
* ITEM OF A PUT ALL.  ROUTINE
* SHOULD SET "A" REG TO ZERO
* IF NOT ALLOWED TO PUT DOWN.
*
* INPUT: A=OBJECT PUTTING DOWN
*******************************

CHKPA EQU *
 TSTA
 RTS


*******************************
* ROUTINE PERFORMED FOR EACH
* ITEM OF A GET ALL.  ROUTINE
* SHOULD SET "A" REG TO ZERO
* IF NOT ALLOWED TO PICK UP.
*
* INPUT: A=OBJECT PICKING UP
*******************************

CHKGA EQU *
 PSHS A
 CMPA #26 MICE
 BNE A@
 LDA #16 TRAP
 JSR HAVOBJ
 BEQ X@
 BRA Y@
A@ CMPA #32 RUG OVER TRAP DOOR
 BEQ X@
 CMPA #19 PADDLES
 BNE Y@
 LDA #112 SNAKE
 JSR CKOBJ
 BEQ Y@
X@ PULS A
 CLRA
 BRA Z@
Y@ PULS A
Z@ TSTA
 RTS

*******************************
* ROUTINE PERFORMED AFTER EACH
* VALID MOVE
*******************************

ECHMOV EQU *
 PSHS D,X,Y
 TST LITECT
 BEQ D@
 TST LITESW
 BEQ D@
 LDB LITECT
 CMPB #19
 BHI C@
 CLRA
 TFR D,X
 LDY #MSG25B
 JSR ASCLNO
 JSR SUPRES
 LDD MSG25B+3
 ADDB #$80
 STD MSG87A
 LDX #MSG87
 JSR DISPLY
C@ DEC LITECT
 BNE D@
 JSR INDARK
 LDA #9
 JSR HAVOBJ
 BEQ A@
 LDB #8
 JSR REPOBJ
 BRA D@
A@ LDA ROOM
 PSHS A
 CLR ROOM
B@ INC ROOM
 LDB ROOM
 CMPB #NORMS
 BHS E@
 LDA #9
 JSR CKOBJ
 BEQ B@
 LDB #8
 JSR CHGOBJ
E@ PULS A
 STA ROOM
D@ PULS D,X,Y,PC

*******************************
*   IN ROOM ROUTINES
*******************************

INRM01 EQU *
 PSHS X
 TST FIRST1
 BNE A@
 INC FIRST1
 LDX #MSG57
 JSR DISPLY
A@ PULS X,PC

INRM06 EQU *
 PSHS A,X
 LDA RANDOM
 ANDA #$7F
 CMPA #35
 BHI A@
 LDX #MSG56
 JSR DISPLY
A@ PULS A,X,PC

INRM24 EQU *
 TST BAILSW
 BNE A@
 LDX #MSG92
 JMP DEAD1
A@ RTS

*******************************
*   ENTER ROOM ROUTINES
*******************************

ENTR03 EQU *
 PSHS D,X
 LDA #9 LIT FLASH
 JSR LOCOBJ
 BNE A@
 LDA RANDOM
 ANDA #$7F
 CMPA #50
 BHI A@
 LDX #MSG102
 JSR DISPLY
A@ PULS D,X,PC

ENTR06 EQU *
 CLR ENERSW
 BRA INRM06

ENTR15 EQU *
 PSHS A
 LDA #17 BOOTS
 JSR HAVOBJ
 BNE A@
 LDX #MSG83
 JMP DEAD1
A@ PULS A,PC

ENTR19 EQU *
 PSHS A,X
 CLR TRADSW
 LDA #125 SIGN
 JSR CKOBJ
 BNE A@
 LDX #MSG58
 JSR DISPLY
A@ PULS A,X,PC

ENTR23 EQU *
 PSHS A
 LDA #22
 STA ROOM
 LDA #102
 JSR PUTOBJ
 LDA #93 INFLATED BOAT
 JSR CKOBJ
 BEQ Z@
 LDA #93 INFLATED BOAT
 LDB #21 DEFLATED BOAT
 JSR CHGOBJ
 LDA #21
 LDB #RMSIZE
 DECA
 MUL
 ADDD #ROOMTB+6
 TFR D,X
 LDB #RMOBJ
A@ LDA ,X+
 BEQ B@
 CMPA #64
 BHI B@
 JSR PUTOBJ
B@ DECB
 BNE A@
 LDA #21
 JSR CLROBJ
 LDA #23
 STA ROOM
Z@ PULS A,PC

ENTR24 EQU *
 PSHS X,U
 CLR BAILSW
 LDU #OVBOT2
 JSR SHOOVL
 LDX #MSG91
 JSR DISPLY
 PULS X,U,PC

*******************************
*   EXIT ROOM ROUTINES
*******************************

EXIT03 EQU *
 PSHS A
 LDA #9 LIT FLASH
 JSR LOCOBJ
 BNE A@
 LDA RANDOM
 ANDA #$7F
 CMPA #40
 BHI A@
 LDX #MSG103
 JMP DEAD1
A@ PULS A,PC

EXIT06 EQU *
 PSHS D
 CMPB #6
 BLO A@
 CMPB #7
 BHI A@
 LDA ROOM
 JSR XFROBJ
A@ PULS D,PC

EXIT19 EQU *
 PSHS D,X
 LDA #125 SIGN
 JSR CKOBJ
 BNE A@
 LDA #23 KEYS
 JSR CKOBJ
 BNE A@
 LDA #24 MACHETE
 JSR CKOBJ
 BNE A@
 LDA ROOM
 JSR CLROBJ
 LDA #110 TRADER JACK
 LDB #125 SIGN
 JSR CHGOBJ
A@ PULS D,X,PC

EXIT22 EQU *
 CMPB #23
 BNE A@
 LDA #102 NATIVES
 JSR CKOBJ
 BEQ A@
 JMP DMSG98
A@ RTS

EXIT24 EQU *
 TST BAILSW
 BNE EXBOAT
 LDX #MSG92
 JMP DEAD1

EXBOAT EQU *
 PSHS D,X,Y
 CMPB #18
 BEQ A@
 CMPB #22
 BEQ A@
 LDA ROOM
 JSR XFROBJ
A@ PULS D,X,Y,PC

*******************************
*  ANTIMATION ROUTINES
*******************************

* MOVE CLOUDS IN SKY

MOVCLO EQU *
 LDX FLIPCT
 LEAX 1,X
 STX FLIPCT
 CMPX #5
 BLO A@
 CLR FLIPCT
 CLR FLIPCT+1
 LDX #GSCRN+(8*32)
 LDD #$200D
 JSR SCRLFT
A@ RTS

* MOVE LASER IN LAB

MOVLSR EQU *
 LDX FLIPCT
 LEAX 1,X
 STX FLIPCT
 CMPX #2
 BLO A@
 CLR FLIPCT
 CLR FLIPCT+1
 LDD #$0601
 LDX #GSCRN+(45*32)+14
 JSR SCRRIT
 INC CLRSW
 LDA CLRSW
 CMPA #5
 BLO A@
 CLR CLRSW
 LDA FLIPSW
 LDU #OVLAB4 SPRING UP
 EORA #1
 BEQ B@
 LDU #OVLAB6 SPRING DOWN
B@ STA FLIPSW
 JSR SHOOVL
A@ RTS

* BLINK LIGHTS IN DEVICE

MOVLIT EQU *
 LDX FLIPCT
 LEAX 1,X
 STX FLIPCT
 CMPX #10
 BLO A@
 CLR FLIPCT
 CLR FLIPCT+1
 LDA RANDOM
 PSHS A
 ANDA #3
 STA COLOR1
 PULS A
 LSRA
 LSRA
 LSRA
 ANDA #3
 CMPA COLOR1
 BNE B@
 INCA
 ANDA #3
B@ STA COLOR2
 LDX #GSCRN+(52*32)+8
 LDD #$0F02
 JSR FLPCLR
A@ RTS

* MOVE SNAKES TAIL

MOVSNK EQU *
 LDA #9 LIT FLASH
 JSR LOCOBJ
 BEQ C@
 LDA #112 SNAKE
 JSR CKOBJ
 BEQ C@
 LDX FLIPCT
 LEAX 1,X
 STX FLIPCT
 CMPX #2
 BLO C@
 CLR FLIPCT
 CLR FLIPCT+1
 LDA FLIPSW
 EORA #1
 STA FLIPSW
 BEQ A@
 LDU #OVSNK2
 BRA B@
A@ LDU #OVSNK3
B@ JSR SHOOVL
C@ RTS

* MOVE CLOCK IN STUDY

MOVCLK EQU *
 LDX FLIPCT
 LEAX 1,X
 STX FLIPCT
 LDA FLIPSW
 BEQ F@
 CMPA #2
 BEQ F@
 CMPX #15
 BLO D@
G@ CLR FLIPCT
 CLR FLIPCT+1
 LDA FLIPSW
 INCA
 STA FLIPSW
 CMPA #1
 BNE A@
 LDU #OVCLK4
 BRA C@
A@ CMPA #3
 BNE B@
 LDU #OVCLK3
 BRA C@
B@ CMPA #2
 BEQ E@
 CLR FLIPSW
E@ LDU #OVCLK2
C@ JSR SHOOVL
D@ RTS
F@ CMPX #8
 BLO D@
 BRA G@
*
* END OF FILE: ADVENT02/ASM
*
